%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Percettrone
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Make a 6x6 square matrix of 2D training data
xin=[[reshape(repmat([0:0.2:1],6,1),[1,6*6])];[repmat([0:0.2:1],1,6)]]';
N = length(xin);
%most are class 0, except a few at lower left
yout=zeros(length(xin));
yout(1:12)=1;
yout(13:15)=1;

%Define a 2D perceptron
b = -0.5;
nu = 0.5;
w = 0.5*rand(3,1); %-1*2.*rand(3,1);
iterations = 100;

%Loop around the training loop
for i = 1:iterations
    for j = 1:N
        y = b*w(1,1)+xin(j,1)*w(2,1)+xin(j,2)*w(3,1);
        z(j) = 1/(1+exp(-2*y));
        delta = yout(j)-z(j);
        w(1,1) = w(1,1)+nu*b*delta;
        w(2,1) = w(2,1)+nu*xin(j,1)*delta;
        w(3,1) = w(3,1)+nu*xin(j,2)*delta;
    end
end

subplot(2,1,1)
hold on
for i=1:N
    if(yout(i)==1)
        plot(xin(i,1),xin(i,2),'ko') %class 1
    else
        plot(xin(i,1),xin(i,2),'ro') %class 0
    end
end

subplot(2,1,2)
NX=1024; %x resolution
NY=1024; %y resolution
dsc=zeros(NX,NY); % plot surface
%classify over this surface
for x=1:NX
    dx=(x-1)/(NX-1); %range 0:1
    for y=1:NY
        dy=(y-1)/(NY-1); %range 0:1
        z=b*w(1,1)+dx*w(2,1)+dy*w(3,1);
        dsc(x,y)=1/(1+exp(-2*z));
    end
end

%classify the original xin points
for j = 1:N
    y=b*w(1,1)+xin(j,1)*w(2,1)+xin(j,2)*w(3,1);
    z(j) = 1/(1+exp(-2*y));
end
%plot the xin points and classifications
hold on
for i=1:N
    if(z(i)>0.5)
        plot(xin(i,1)*NX,xin(i,2)*NY,'k*') %class 1
    else
        plot(xin(i,1)*NX,xin(i,2)*NY,'r*') %class 0
    end
end
%overlay the decision line on the plot
contour(transpose(dsc > 0.5),1)





