%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%               PCA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[sp,fs]=audioread('SA1.WAV'); %load speech
sp=sp'./max(abs(sp)); %normalise
N=2;
T=length(sp);
tone1=tonegen(440,fs,T/fs); %create a tone
M=2; %create 2 mixtures of these sounds
mix1=sp*0.23+tone1*0.58;
mix2=sp*0.81+tone1*0.19;
X=[mix1 ; mix2]; %mixture matrix
%dimension of X is [M][T]


nu=0.01; %learning rate
conv=1e-09; %convergence criterion
%---create an [N][M] sized matrix W
W=rand(N,M)*0.1;
%---estimate the source, Sp, dim [N][t]
iter=1;
max_iter=500000;
while(iter < max_iter)
    
%     if(rem(iter,10000)==0)
%         nu = nu*0.7;
%     end
    
    Sp=W*X;
    Z=zeros(N,T);
    for n=1:N
        Z(n,:)=1./(1+exp(-Sp(n,:)/2));
    end
    %----calculate DW (deltaW)
    DW=nu*(eye(N) + (1-2*Z)*transpose(Sp))*W;
    %---terminate if converged
    delta=abs(sum(sum(DW)));
    if(delta < conv)
        break;
    end
    %print out (so we know what's happening)
    if mod(iter,100)==0
        fprintf('Iteration %d, sum=%g\n',iter,delta);
    end
    %---apply the update
    W=W+DW;
    iter=iter+1;
end

subplot(2,3,1);
plot(sp); axis tight;

subplot(2,3,4);
plot(tone1); axis tight;

subplot(2,3,2);
plot(mix1); axis tight;

subplot(2,3,5);
plot(mix2); axis tight;


subplot(2,3,3);
plot(Sp(1,:)); axis tight;

subplot(2,3,6);
plot(Sp(2,:)); axis tight;

%soundsc(mix2,fs)
%soundsc(Sp(2,:),fs)